<!-- render errors -->
<ng-container *ngFor="let code of errorCodes">
  <!-- field error -->
  <app-field-error *ngIf="hasError(code)">
    {{ errors[code] }}
  </app-field-error>
</ng-container>

<!-- field -->
<div [class.error]="invalid" [class.focus]="focused" [class.has-value]="control.value" class="app-materialized-field">
  <!-- key icon -->
  <app-icon-key></app-icon-key>

  <!-- input area -->
  <div class="app-input-area">
    <!-- label -->
    <div class="app-label">
      {{ label }}
    </div>

    <!-- input -->
    <input
      #input
      (blur)="blur()"
      (focus)="focus()"
      [formControl]="control"
      [type]="type"
      class="app-input"
      spellcheck="false"
    />
  </div>

  <!-- eye icon -->
  <app-icon-eye (click)="togglePasswordVisible()"></app-icon-eye>
</div>
